/*
 * UCB-BF504 I2CLN^LCDR[h
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * ̃TvR[hɂẮALURLQƂB
 * http://kaneko-sys.co.jp/support/
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <stdint.h>
#include <string.h>

/* RANbN(400MHz) */
#define CCLOCK_HZ		(400000000)
/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)

#define TWI_COUNT(x) (DCNT & ((x) << 6))
/* TWIp߂l */
#define NO_ERROR		(0)
#define TWI_ERROR_NAK	(-1)
/* s_twi_master_writerstartp` */
#define TWI_STOP		(0)
#define TWI_RSTART		(1)

/* LCDI2CfoCXAhX */
#define TWI_DEVICE_ADDR	(0x50)

/* TWI(I2C)p֐ */
void s_twi_init(void);
/* TWI(I2C)f[^Mp֐ */
int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt);

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
	uint32_t l_start;
	uint32_t l_now;
	uint32_t l_stop = us * (1000 / 2.5);	/* 1 cycle = 2.5ns */

	asm("%0 = CYCLES;" : "=d"(l_start));
	while(1)
	{
		asm("%0 = CYCLES;" : "=d"(l_now));
		l_now -= l_start;
		if(l_now >= l_stop)
			break;
	}
}

/* LCDɃR}h𑗐M */
static void s_lcd_cmd_write(uint8_t cmd)
{
	uint8_t l_data[2];
	
	l_data[0] = 0x00;
	l_data[1] = cmd;
	s_twi_master_write(TWI_DEVICE_ADDR, TWI_STOP, l_data, 2);
}

/* LCDɃf[^𑗐M */
static void s_lcd_data_write(uint8_t data)
{
	uint8_t l_data[2];
	
	l_data[0] = 0x80;
	l_data[1] = data;
	s_twi_master_write(TWI_DEVICE_ADDR, TWI_STOP, l_data, 2);
}

/* LCDɕ\ */
static void s_lcd_puts(const char* p_text)
{
	int32_t l_lc, l_len;
	
	l_len = strlen(p_text);

	s_lcd_cmd_write(0x80);
	s_us_delay(60);		/* 60us */
	for(l_lc = 0; l_lc < l_len; l_lc++)
	{
		s_lcd_data_write(p_text[l_lc]);
		s_us_delay(60);		/* 60us */
	}
}

/* LCD */
static void s_lcd_init(void)
{
	int32_t l_lc;
	
	s_us_delay(15000);	/* 15ms */
	s_lcd_cmd_write(0x01);
	s_us_delay(3000);	/* 3ms */
	s_lcd_cmd_write(0x38);
	s_us_delay(60);		/* 60us */
	s_lcd_cmd_write(0x0F);
	s_us_delay(60);		/* 60us */
	s_lcd_cmd_write(0x06);
}

void main(void)
{
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);
	
	/* TWI(I2C) */
	s_twi_init();
	/* LCD */
	s_lcd_init();
	
	while(1)
	{
		s_lcd_puts("Blackfin de LCD");
		s_us_delay(800000);		/* 800ms */
		s_lcd_puts("               ");
		s_us_delay(200000);		/* 200ms */
	}
}

/* TWI(I2C) */
static void s_twi_init(void)
{
	*pTWI_CONTROL = 0;
	ssync();
	*pTWI_CONTROL = TWI_ENA | 30U;		/* LCDI2CNbN100kHzŒʐMĂ܂łH */
	*pTWI_CLKDIV  = CLKHI(50) | CLKLOW(50);
	*pTWI_INT_MASK = RCVSERV | XMTSERV | MERR | MCOMP;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;
	ssync();
}

static int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt)
{
	int32_t l_idx;
	
	if(write_cnt <= 0)
	{
		return NO_ERROR;
	}

	*pTWI_FIFO_CTL = 0;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_MASTER_STAT = BUFWRERR | BUFRDERR | LOSTARB | ANAK | DNAK;
	*pTWI_MASTER_ADDR = slave_addr;
	// Send first byte
	*pTWI_XMT_DATA8 = p_data[0];
	*pTWI_MASTER_CTL = TWI_COUNT(write_cnt) | MEN | (rstart ? RSTART : 0);
	ssync();

	for(l_idx = 1; l_idx < write_cnt; l_idx++)
	{
		while(((*pTWI_INT_STAT & MERR) == 0U) && (*pTWI_FIFO_STAT == XMTSTAT)) ssync();
		*pTWI_XMT_DATA8 = p_data[l_idx];
		ssync();
	}

	/* ]I܂őҋ@ */
	while((*pTWI_INT_STAT & MCOMP) == 0U) ssync();
	if((*pTWI_INT_STAT & MERR) == 0U)
	{
		return NO_ERROR;
	}
	else
	{
		return TWI_ERROR_NAK;
	}
}
